; bitflip_if.a51 	toggle LED, slowly--if pushbutton NOT pressed

; rev path 3/16
	$NOSYMBOLS	; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 

	BLUE_LED EQU P0.0
	PB EQU P0.4				; pushbutton will determine whether LED is to toggle or not

	ORG 0					; tells assembler the address at which to place this code
	
	SJMP STARTUP		; 	here code begins--with just a jump to start of
					;   real program.  ALL our programs will start thus							
	ORG 80h				;  ...and here the program starts
	
STARTUP: acall USUAL_SETUP
			acall DELAY_INITS
    	setb BLUE_LED			;  start high (LED off), just to make it predictable	

			
FLIPIT:	jnb PB, FLIPIT		; hang up here, so long as pushbuttom is pressed
			cpl BLUE_LED	; ...but flip the LED when button not pushed
			acall DELAY
			sjmp FLIPIT


;----SUBROUTINES ------			
USUAL_SETUP:            ; Disable the WDT.
            anl   PCA0MD, #NOT(040h)   ; Clear Watchdog Enable bit

						; Configure the Oscillator
            orl   OSCICN, #04h         ; sysclk = 24.5 Mhz / 8, for lower power

            ; Enable the Port I/O Crossbar
           mov   XBR1, #40h           ; Enable Crossbar
					 						ret

DELAY:	push ACC				; save registers that'll get messed up
			push B
			push 4				; ...and R4 (this was initialized elsewhere)
SECOND_LOOP:	mov A,R2				; get outer-loop delay value
INITINNER:	mov B,R3			; initialize inner loop counter
INLOOP:	DJNZ B, INLOOP		; count down inner loop, till inner hits zero
			DJNZ ACC,INITINNER	; ...then dec outer, and start inner again.
			DJNZ R4, SECOND_LOOP	; now the outermost loop
			pop 4					; restore saved registers
			pop B  				
			pop ACC
			ret					; Now back to main program.

DELAY_INITS:			CLR A			; maximize delays
			mov R2, A	; roundabout way to clear 2 registers
			mov R3, A
			mov R4, #10; third loop for about 1 sec delay	
			ret		

END

